package footyquiz.server.integration;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
/**
 * Stores the SQL command and the accsess to
 * the database fot the highscore table.
 * @author Hannu Leinonen
 *
 */
public class HighscoreDAO {
    private DatabaseConnector db;
    private final String SELECT_MIN_HIGHSCORE = "SELECT id, score FROM highscore WHERE score = (SELECT MIN(score) FROM highscore) ORDER BY id DESC;";
    private final String SELECT_HIGHSCORES = "SELECT id, username, score FROM highscore ORDER BY score DESC LIMIT 0, 10;";
    private final String DELETE_SCORE = "DELETE FROM highscore WHERE id = ?;";
    private final String INSERT_SCORE = "INSERT INTO highscore (username, score) VALUES (?, ?)";
    private final String SELECT_MAX_HIGHSCORE_ID = "SELECT max(id) AS id from highscore";
    private final String SELECT_COUNT_HIGHSCORE = "SELECT count(id) AS count from highscore";
    /**
     * Gets the samllest value in the highscore table.
     * @return
     */
    @SuppressWarnings("unchecked")
	public List<Map> getMinHighscore() {
    	db = new DatabaseConnector();
    	return db.executeQuery(SELECT_MIN_HIGHSCORE, true);
    }
    /**
     * Gets the amount of highscores rows.
     * @return
     */
    @SuppressWarnings("unchecked")
	public List<Map> getHighscoreCount() {
    	db = new DatabaseConnector();
    	return db.executeQuery(SELECT_COUNT_HIGHSCORE, true);
    }
    /**
     * Gets the highscores.
     * @return
     */
    @SuppressWarnings("unchecked")
	public List<Map> getHighscores() {
    	db = new DatabaseConnector();
    	return db.executeQuery(SELECT_HIGHSCORES, true);
    }
    /**
     * Updates the highscores in the database.
     * @param id
     * @param username
     * @param score
     * @return
     */
	public int updateScore(int id, String username, int score) {
    	db = new DatabaseConnector();
    	db.createConnection();
    	if(id != 0) {
	    	List<String> delete = new ArrayList<String>();
	    	delete.add("" + id);
			db.executeSQL(DELETE_SCORE, delete, false);
    	}
    	List<String> insert = new ArrayList<String>();
    	insert.add(username);
    	insert.add("" + score);
		db.executeSQL(INSERT_SCORE, insert, false);
		List l = db.executeQuery(SELECT_MAX_HIGHSCORE_ID, false);
		int lastInsertId = Integer.parseInt((String) ((Map) l.get(0)).get("id"));
		System.out.println("vika id: " + lastInsertId);
		db.closeConnection();
		return lastInsertId;
	}
}
